//+------------------------------------------------------------------+
//|                                             Weighed DTOmulty.mq4 |
//|                                   Copyleft  2010 Zakharov Vadim |
//|                                                   aka Yuritch    |
//+------------------------------------------------------------------+

#property  indicator_separate_window
#property indicator_buffers     2
#property indicator_color1      DodgerBlue
#property indicator_color2      Orange
#property indicator_width1      2
#property indicator_width2      1
#property indicator_level1      20
#property indicator_level2      50
#property indicator_level3      80
#property indicator_levelcolor  Gray

//---- input parameters
extern bool      alert=false;
extern int       rsiLength=13;
extern int       kLength=12;
extern int       DLength=3;
extern int       KSmooth=6;

extern bool   SmoothKLine=true;
extern int    NumPairs = 8;
extern int    TF       = 0;
extern string Pairs1   = "GBPUSD";
extern string Pairs2   = "EURJPY";
extern string Pairs3   = "AUDUSD";
extern string Pairs4   = "NZDJPY";
extern string Pairs5   = "EURUSD";
extern string Pairs6   = "GBPJPY";
extern string Pairs7   = "NZDUSD";
extern string Pairs8   = "AUDJPY";
extern string Pairs9   = "CHFJPY";
extern string Pairs10  = "EURCHF";
extern string Pairs11  = "GBPCHF";
extern string Pairs12  = "USDJPY";
extern string Pairs13  = "CADJPY";
extern string Pairs14  = "EURGBP";
extern int    Mode     = 0;
extern int    Limit    = 14;


double buf0[], buf1[];
string Pairs[],suff="";
bool Recalculate=true;
bool buy_gudok=true;
bool sell_gudok=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorShortName("WDTOM("+NumPairs+")("+TF+")");
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexStyle(1,DRAW_LINE,0,1);
   SetIndexBuffer(0,buf0);
   SetIndexBuffer(1,buf1);
   ArrayResize(Pairs,NumPairs);
   
  if (StringLen(Symbol()) >6)
     {
     suff=StringSubstr(Symbol(),6,0);
     }

   if (NumPairs > 0) Pairs[0] = Pairs1+suff;
   if (NumPairs > 1) Pairs[1] = Pairs2+suff;
   if (NumPairs > 2) Pairs[2] = Pairs3+suff;
   if (NumPairs > 3) Pairs[3] = Pairs4+suff;
   if (NumPairs > 4) Pairs[4] = Pairs5+suff;
   if (NumPairs > 5) Pairs[5] = Pairs6+suff;
   if (NumPairs > 6) Pairs[6] = Pairs7+suff;
   if (NumPairs > 7) Pairs[7] = Pairs8+suff;
   if (NumPairs > 8) Pairs[8] = Pairs9+suff;
   if (NumPairs > 9) Pairs[9] = Pairs10+suff;
   if (NumPairs > 10) Pairs[10] = Pairs11+suff;
   if (NumPairs > 11) Pairs[11] = Pairs12+suff;
   if (NumPairs > 12) Pairs[12] = Pairs13+suff;
   if (NumPairs > 13) Pairs[13] = Pairs14+suff;

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

   if (Recalculate) 
      {
         ObjectCreate("dtom",OBJ_LABEL,WindowFind("WDTOM("+NumPairs+")("+TF+")"),0,0);
         ObjectSet("dtom", OBJPROP_XDISTANCE, 5);
         ObjectSet("dtom", OBJPROP_YDISTANCE, 5);
         ObjectSetText("dtom"," ",12,"Calibri Bold",Yellow);
      }
    else ObjectDelete("dtom");
    
   int limit;
   double weight_sum=0,weight;
   
   limit = Bars;
   int i, j;
   double tmp0, tmp1;
   for(j = 0; j < NumPairs; j++) {
   weight_sum = weight_sum + MarketInfo(Pairs[j],MODE_TICKVALUE);
   }
   if (limit>Limit && Limit>0 && !Recalculate) limit=Limit;
   for(i = limit; i > -1; i--) {
      tmp0 = 0.0;
      tmp1 = 0.0;
      int timebar=iTime(NULL,TF,i);
      
      for(j = 0; j < NumPairs; j++) {
         weight=MarketInfo(Pairs[j],MODE_TICKVALUE)/weight_sum;
         int shift=iBarShift(Pairs[j],TF,timebar);
         if (iTime(NULL,TF,i)<iTime(Pairs[j],TF,shift)) shift++;
         tmp0 = tmp0 + iCustom(Pairs[j], TF,"DTOsc",rsiLength,kLength,KSmooth,DLength,SmoothKLine,0, shift)*weight;
         tmp1 = tmp1 + iCustom(Pairs[j], TF,"DTOsc",rsiLength,kLength,KSmooth,DLength,SmoothKLine,1, shift)*weight;
      }
      buf0[i] = tmp0;
      buf1[i] = tmp1;
      
 if (i==0 && alert)
 {
   if (buf1[i] >= 80 && buf1[i]>buf0[i] && sell_gudok)
   {
   Alert("  ");
   sell_gudok=false;
   buy_gudok=true;
   }
   if (buf1[i] <= 20 && buf1[i]<buf0[i] && buy_gudok)
   {
   Alert("  ");
   sell_gudok=true;
   buy_gudok=false;
   }
   }
  }
  Recalculate=false;
   return(0);
}

